Modify

Opened 9 years ago

Closed 8 years ago

Last modified 8 years ago

#2642 closed Bugs (fixed)

bug constructing from a reference to another boost::function

Reported by: Steven Watanabe Owned by: Douglas Gregor
Milestone: Boost 1.38.0 Component: function
Version: Boost 1.37.0 Severity: Problem
Keywords: Cc:

Description

The following code throws a bad_function_call exception because the constructor for f2 decides that since f1 is empty, f2 ought to be empty as well.

#include <boost/function.hpp>
#include <boost/ref.hpp>

void f() {
}

int main() {
    boost::function<void()> f1;
    boost::function<void()> f2(boost::ref(f1));
    f1 = f;
    f2();
}

The attached patch fixes the problem.

Attachments (1)

function_template.hpp.patch (1.1 KB) - added by Steven Watanabe 9 years ago.

Download all attachments as: .zip

Change History (6)

Changed 9 years ago by Steven Watanabe

Attachment: function_template.hpp.patch added

comment:1 Changed 8 years ago by Daniel James

Resolution: fixed
Status: newclosed

(In [54616]) When copying boost::ref, copy even when the referenced function is empty. Fixes #2642

Patch by Steven Watanabe

comment:2 Changed 8 years ago by Daniel James

(In [54824]) Merge various function changes from trunk.

Merged revisions 49571,50064,51743,51745,53722,54616-54619 via svnmerge from https://svn.boost.org/svn/boost/trunk

........

r49571 | noel_belcourt | 2008-11-03 18:37:49 +0000 (Mon, 03 Nov 2008) | 9 lines

Both Sun and Pgi on Linux correctly put typeinfo into the std namespace, but function_base keys off the BOOST_NO_EXCEPTION_STD_NAMESPACE macro instead of the BOOST_NO_STD_TYPEINFO macro. The attached patch changes function_base to use the typeinfo macro. Because eVC 4.2 doesn't put typeinfo into the std namespace, I need to define BOOST_NO_STD_TYPEINFO only for this eVC version.

........

r50064 | johnmaddock | 2008-12-02 10:10:46 +0000 (Tue, 02 Dec 2008) | 1 line

Fix -Wundef warning and suspect usage of BOOST_STRICT_CONFIG.

........

r51743 | dgregor | 2009-03-13 05:23:53 +0000 (Fri, 13 Mar 2009) | 11 lines

Implement an optimization that David Abrahams and myself came up with, where Boost.Function uses a bit in the vtable pointer to indicate when the target function object has a trivial copy constructor, trivial destructor, and fits within the small object buffer. In this case, we just copy the bits of the function object rather than performing an indirect call to the manager.

This results in a 60% speedup on a micro-benchmark that copies and calls such function objects repeatedly.

........

r51745 | dgregor | 2009-03-13 05:49:02 +0000 (Fri, 13 Mar 2009) | 7 lines

Make Boost.Function compile under BOOST_NO_EXCEPTIONS.

Fixes #2499 Fixes #2494 Fixes #2469 Fixes #2466

........

r53722 | vladimir_prus | 2009-06-07 16:44:50 +0100 (Sun, 07 Jun 2009) | 4 lines

Make Boost.Function compile with disabled exceptions.

Closes #2900. Patch from Gabi Davar.

........

r54616 | danieljames | 2009-07-03 23:20:26 +0100 (Fri, 03 Jul 2009) | 3 lines

When copying boost::ref, copy even when the referenced function is empty. Fixes #2642

Patch by Steven Watanabe

........

r54617 | danieljames | 2009-07-03 23:20:52 +0100 (Fri, 03 Jul 2009) | 6 lines

Add 'and later versions' to support info for GCC and Visual C++. Fixes #2847.

I didn't explicitly specify the versions since no one's updating this list and it's highly unlikely that a future version will break this. The same could probably be done for the other compilers but I don't know them very well so I'm leaving them alone.

........

r54618 | danieljames | 2009-07-03 23:21:40 +0100 (Fri, 03 Jul 2009) | 4 lines

Fix Boost.Function unit tests for C++0x. Fixes #3012

Based on a patch from Richard Webb. Changed a bit so that it also works for the Visual C++ 10 beta.

........

r54619 | danieljames | 2009-07-03 23:22:03 +0100 (Fri, 03 Jul 2009) | 3 lines

Work around Visual C++ copy constructor bug. Fixes #2929.

Based on the patch by Steven Watanabe.

........

comment:3 Changed 8 years ago by Yusaku Sugai <sugai@…>

Resolution: fixed
Status: closedreopened

The following code throws a bad_function_call exception with Boost 1.40.0.
It was OK with Boost 1.38.0.
I suppose #2642 patch made reference to function(empty or not) to be always non-empty.

#include <boost/function.hpp>
#include <boost/ref.hpp>

int main() {
    boost::function<void()> f1;
    boost::function<void()> f2(boost::ref(f1));
    if (f2) {
        f2();
    }
}

comment:4 Changed 8 years ago by Steven Watanabe

Resolution: fixed
Status: reopenedclosed

This behavior is correct. f2 is not empty. That what it holds happens to be a reference to an empty boost::function is irrelevant. BTW, before 1.40, you could get a bad_function_call with

#include <boost/function.hpp>
#include <boost/ref.hpp>

void f() {}

int main() {
    boost::function<void()> f1(&f);
    boost::function<void()> f2(boost::ref(f1));
    f1.clear();
    if (f2) {
        f2();
    }
}

comment:5 Changed 8 years ago by Yusaku Sugai <sugai@…>

I understand that in a sense f2 is not empty.
I expected that

f.empty() is false => It's OK to call f().
f.empty() is true => It's not OK to call f().

But it is not what empty()-ness means in function library, right?

Is there any way to know in advance whether it is OK to call a function object or not?
Do I have to just try calling it and be ready for bad_function_call exception?

Modify Ticket

Change Properties
Set your email in Preferences
Action
as closed The owner will remain Douglas Gregor.
The resolution will be deleted.

Add Comment


E-mail address and name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.